/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2016 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mcicmd.h,v 1.0 2016/01/20 18:45:12 roi Exp $
 */

#ifndef _MCICMD_H_
#define _MCICMD_H_

#define MCIPCB              SDCARD_Handler_t
#define MCIINFO             SDCARD_CardInfo_t

#define SDDEV_BUS_WIDE_4B   SDMMC_BUS_WIDE_4B
#define DMA_ALINE

#define mci_ses_por         sdcard_init
#define mci_opn_por         sdcard_open
#define mci_cls_por         sdcard_close
#define MciCheckCID         sdcard_checkCID
#define MciSetAddress       sdcard_dummy
#define MciSendCID          sdcard_sendCSD
#define MciGetCardInfo      sdcard_getcardinfo
#define MciSelectCard       sdcard_select_card
#define MciConfiguration    sdcard_configuration
#define MciSetWideBus       sdcard_dummy
#define mci_red_blk         sdcard_blockread
#define mci_wri_blk         sdcard_blockwrite
#define mci_wai_trn         sdcard_wait_transfar

#include "spi_driver.h"

#endif

