/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: dwc2_device_driver.h 698 2017-09-23 16:44:40Z roi $
 */
/*
 *  DWC2 DEVICE HIGH DRIVER 󥯥롼ɥե
 */


#ifndef _DWC2_DEVICE_DRIVER_H_
#define _DWC2_DEVICE_DRIVER_H_

#include "tusb_rtos.h"
#include "usb_otg.h"

#ifdef __cplusplus
 extern "C" {
#endif

#define dwc2_device_getrxdatasize(d, a)  (((USB_OTG_Handle_t *)((d)->pSysData))->OUT_ep[(a) & 0x7F].xfer_count)

/*
 *  DWC2 DEVICE HIGH DRIVERؿץȥ
 */
extern TUSBD_ERCODE dwc2_device_init(TUSBD_Handle_t *pdevice);
extern TUSBD_ERCODE dwc2_device_deinit(TUSBD_Handle_t *pdevice);
extern TUSBD_ERCODE dwc2_device_start(TUSBD_Handle_t *pdevice);
extern TUSBD_ERCODE dwc2_device_stop(TUSBD_Handle_t *pdevice);
extern TUSBD_ERCODE dwc2_device_openep(TUSBD_Handle_t *pdevice, uint8_t addr, uint8_t type, uint16_t mps);
extern TUSBD_ERCODE dwc2_device_closeep(TUSBD_Handle_t *pdevice, uint8_t addr);
extern TUSBD_ERCODE dwc2_device_flushep(TUSBD_Handle_t *pdevice, uint8_t addr);
extern TUSBD_ERCODE dwc2_device_stallep(TUSBD_Handle_t *pdevice, uint8_t addr);
extern TUSBD_ERCODE dwc2_device_clearep(TUSBD_Handle_t *pdevice, uint8_t addr);
extern uint8_t      dwc2_device_getstallcondition(TUSBD_Handle_t *pdevice, uint8_t addr);
extern TUSBD_ERCODE dwc2_device_transmitdata(TUSBD_Handle_t *pdevice, uint8_t addr, uint8_t *pbuf, uint16_t size);
extern TUSBD_ERCODE dwc2_device_startreceive(TUSBD_Handle_t *pdevice, uint8_t addr, uint8_t *pbuf, uint16_t size);
extern TUSBD_ERCODE dwc2_device_testmode(TUSBD_Handle_t *pdevice);


#ifdef __cplusplus
}
#endif

#endif /* _DWC2_DEVICE_DRIVER_H_ */

