/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: fonts.h 2416 2018-10-03 21:32:24Z roi $
 */

/*
 *  FONTΥإåե
 */

#ifndef _FONTS_H_
#define _FONTS_H_

#ifdef __cplusplus
 extern "C" {
#endif

#include <t_stddef.h>

#define NUM_FONTS   224

#ifndef TOPPERS_MACRO_ONLY

/*
 *  FONT¤
 */
typedef struct _font_s {
	uint8_t     width;
	uint8_t     height;
	uint8_t     stride;
	uint8_t     iheight;
	uint8_t     image[8];
} font_t;

/*
 *  FONTإå¤
 */
typedef struct _font_head_s {
	const char  font_name[32];
	uint8_t     file_attribute;
	uint8_t     font_attribute;
	uint8_t     font_width;
	uint8_t     font_height;
	const font_t **font_table;
	void        *pdata;
} font_head_t;

typedef struct font_file_head_s {
	char           magic[4];
	char           name[32];
	unsigned int   fsize;
	unsigned int   csize;
	unsigned int   isize;
	unsigned int   off_cnv_table1;
	unsigned int   siz_cnv_table1;
	unsigned int   off_cnv_table2;
	unsigned int   siz_cnv_table2;
	unsigned int   off_cnv_table3;
	unsigned int   siz_cnv_table3;
	unsigned int   off_2byte_font;
	unsigned int   siz_2byte_font;
	unsigned int   off_3byte_font;
	unsigned int   siz_3byte_font;
} font_file_head_t;

extern font_head_t Embedded_Font9;
extern font_head_t Shinonome_Font12;
extern font_head_t Shinonome_Font16;


#endif /* TOPPERS_MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif

