/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2018 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: glcd_disp.h 001 2018-10-17 17:58:27Z roi $
 */

#ifndef _GLCD_DISP_H_
#define _GLCD_DISP_H_

#ifdef __cplusplus
 extern "C" {
#endif 

#include "glcd_core.h"
#include "fonts.h"

/*
 *  ƥɽ饤⡼
 */
typedef enum
{
	CENTER_MODE = 0x01,	/* Center mode */
	RIGHT_MODE,			/* Right mode  */
	LEFT_MODE			/* Left mode   */
}Line_ModeTypdef;


#define Font8   Embedded_Font9
#define Font12  Shinonome_Font12
#define Font16  Shinonome_Font16

/*
 *  BSPɽؿѴ
 */
#define BSP_LCD_Init()                  lcd_init(pHLCD, LCD_ORIENTATION_LANDSCAPE)
#define BSP_LCD_DeInit()                lcd_deinit(pHLCD)
#define BSP_LCD_LayerDefaultInit(a, b)  lcd_layerdefaultinit(pHLCD, pDRAWPROP, (a), (b))
#define BSP_LCD_SetLayerWindow(i, x, y, w, h) lcd_setAddrWindow(pHLCD, (i), (x), (y), (w), (h))

#define BSP_LCD_Clear(c)                lcd_clear(pHLCD, (c))
#define BSP_LCD_ReadPixel(x, y)         lcd_readPixel(pHLCD, (x), (y))
#define BSP_LCD_DrawPixel(x, y, c)      lcd_drawPixel(pHLCD, (x), (y), (c))
#define BSP_LCD_DrawHLine(x, y, w)      lcd_drawFastHLine(pHLCD, (x), (y), (w), pDRAWPROP->TextColor)
#define BSP_LCD_DrawVLine(x, y, h)      lcd_drawFastVLine(pHLCD, (x), (y), (h), pDRAWPROP->TextColor)
#define BSP_LCD_DrawBitmap(x, y, p)     lcd_drawBitmap(pHLCD, (x), (y), (p))
#define BSP_LCD_DrawRGBImage(x, y, xs, ys, p) lcd_drawRGBImage(pHLCD, (x), (y), (xs), (xy), (p))
#define BSP_LCD_DisplayOn()             lcd_displayOn(pHLCD)
#define BSP_LCD_DisplayOff()            lcd_displayOff(pHLCD)
#define BSP_LCD_FillRect(x, y, w,h)     lcd_fillRect(pHLCD, (x), (y), (w), (h), pDRAWPROP->TextColor)

#define BSP_LCD_DrawLine(x, y, x2, y2)  lcd_drawLine(pDRAWPROP, (x), (y), (x2), (y2))
#define BSP_LCD_DrawRect(x, y, w, h)    lcd_drawRect(pDRAWPROP, (x), (y), (w), (h))
#define BSP_LCD_DrawCircle(x, y, r)     lcd_DrawCircle(pDRAWPROP, (x), (y), (r))
#define BSP_LCD_DrawEllipse(x, y, xr, yr) lcd_DrawEllipse(pDRAWPROP, (x), (y), (xr), (yr))
#define BSP_LCD_DrawPolygon(a, b)       lcd_drawPolygon(pDRAWPROP, (a), (b))
#define BSP_LCD_FillCircle(x, y, r)     lcd_fillCircle(pDRAWPROP, (x), (y), (r))
#define BSP_LCD_FillEllipse(x, y, xr, yr) lcd_fillEllipse(pDRAWPROP, (x), (y), (xr), (yr))
#define BSP_LCD_FillPolygon(a, b)       lcd_fillPolygon(pDRAWPROP, (a), (b))

#define BSP_LCD_ClearStringLine(l)      lcd_clearStringLine(pDRAWPROP, (l))
#define BSP_LCD_DisplayChar(x, y, a)    lcd_DisplayChar(pDRAWPROP, (x), (y), (a))
#define BSP_LCD_DisplayStringAt(x, y, t, m) lcd_DisplayStringAt(pDRAWPROP, (x), (y), (t), (m))
#define BSP_LCD_DisplayStringAtLine(l, p) lcd_DisplayStringAtLine(pDRAWPROP, (l), (p))

#define BSP_LCD_SelectLayer(a)          pHLCD->layer = (a)
#define BSP_LCD_GetXSize()              pHLCD->_width
#define BSP_LCD_GetYSize()              pHLCD->_height
#define BSP_LCD_SetTextColor(c)         pDRAWPROP->TextColor = (c)
#define BSP_LCD_GetTextColor()          pDRAWPROP->TextColor
#define BSP_LCD_SetBackColor(c)         pDRAWPROP->BackColor = (c)
#define BSP_LCD_GetBackColor()          pDRAWPROP->BackColor
#define BSP_LCD_SetFont(f)              pDRAWPROP->pFont = (f)
#define BSP_LCD_GetFont()               ((sFONT *)pDRAWPROP->pFont)


extern const font_t *lcd_getFontTable(font_head_t *phead, uint8_t *ptr);
extern void lcd_clearStringLine(LCD_DrawProp_t *pDrawProp, uint16_t Line);
extern void lcd_DisplayChar(LCD_DrawProp_t *pDrawProp, uint16_t Xpos, uint16_t Ypos, uint8_t Ascii);
extern void lcd_DisplayStringAt(LCD_DrawProp_t *pDrawProp, uint16_t Xpos, uint16_t Ypos, uint8_t *Text, Line_ModeTypdef Mode);
extern void lcd_DisplayStringAtLine(LCD_DrawProp_t *pDrawProp, uint16_t Line, uint8_t *ptr);

#ifdef __cplusplus
}
#endif

#endif /* _GLCD_DISP_H_ */

