/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: sample1.h 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/*
 *		ץץ(1)Υإåե
 */

/*
 *  åȰ¸
 */
#include "target_test.h"

#include "device.h"
#include "i2c.h"
#include "stlcd_st7789h2.h"
#include "stts_ft06x06.h"
#include "staudio_wm8994.h"
#include "glcd_disp.h"

/*
 *  ƥͥ٤
 */

#define MAIN_PRIORITY	8		/* ᥤ󥿥ͥ */
								/* HIGH_PRIORITY⤯뤳 */

/*
 *  åȤ˰¸ǽΤ
 */

#ifndef TASK_PORTID
#define	TASK_PORTID		1			/* ʸϤ륷ꥢݡID */
#endif /* TASK_PORTID */

#ifndef STACK_SIZE
#define	STACK_SIZE		4096		/* Υå */
#endif /* STACK_SIZE */

#define I2C_AD_PORTID    I2C1_PORTID
#define INHNO_I2CADEV    IRQ_VECTOR_I2C1_EV	/* ߥϥɥֹ */
#define INTNO_I2CADEV    IRQ_VECTOR_I2C1_EV	/* ֹ */
#define INTPRI_I2CADEV   -5			/* ͥ */
#define INTATR_I2CADEV   0			/* ° */

#define INHNO_I2CADER    IRQ_VECTOR_I2C1_ER	/* ߥϥɥֹ */
#define INTNO_I2CADER    IRQ_VECTOR_I2C1_ER	/* ֹ */
#define INTPRI_I2CADER   -5			/* ͥ */
#define INTATR_I2CADER   0			/* ° */

#define I2C_TS_PORTID    I2C3_PORTID
#define INHNO_I2CTSEV    IRQ_VECTOR_I2C3_EV	/* ߥϥɥֹ */
#define INTNO_I2CTSEV    IRQ_VECTOR_I2C3_EV	/* ֹ */
#define INTPRI_I2CTSEV   -5			/* ͥ */
#define INTATR_I2CTSEV   0			/* ° */

#define INHNO_I2CTSER    IRQ_VECTOR_I2C3_ER	/* ߥϥɥֹ */
#define INTNO_I2CTSER    IRQ_VECTOR_I2C3_ER	/* ֹ */
#define INTPRI_I2CTSER   -5			/* ͥ */
#define INTATR_I2CTSER   0			/* ° */

#define INHNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ߥϥɥֹ */
#define INTNO_DMAS24    IRQ_VECTOR_DMA2_STREAM4	/* ֹ */
#define INTPRI_DMAS24   -4			/* ͥ */
#define INTATR_DMAS24   0				/* ° */

#define INHNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ߥϥɥֹ */
#define INTNO_DMAS26    IRQ_VECTOR_DMA2_STREAM6	/* ֹ */
#define INTPRI_DMAS26   -4			/* ͥ */
#define INTATR_DMAS26   0				/* ° */


#define pHLCD           (&LcdHandle)
#define pDRAWPROP       (&DrawProp)

#define BSP_TS_Init(a, b)               touchscreen_init(&TouchScreen_Handle, (a), (b), TS_ORIENTATION_LANDSCAPE)
#define BSP_TS_GetState(a)              touchscreen_getstate(&TouchScreen_Handle, (a))
#define BSP_TS_Get_GestureId(a)         touchscreen_get_gestureid(&TouchScreen_Handle, (a))
#define BSP_TS_ResetTouchData           touchscreen_reset_data

#define BSP_AUDIO_OUT_Init(a, b, c)     staudio_out_init(&Audio_Handle, (a), (b), (c), 64)
#define BSP_AUDIO_OUT_DeInit()          staudio_out_deinit(&Audio_Handle)
#define BSP_AUDIO_OUT_Play(a, b)        staudio_out_play(&Audio_Handle, (a), (b))
#define BSP_AUDIO_OUT_Pause()           staudio_out_pause(&Audio_Handle)
#define BSP_AUDIO_OUT_Resume()          staudio_out_resume(&Audio_Handle)
#define BSP_AUDIO_OUT_Stop(a)           staudio_out_stop(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetVolume(a)      staudio_out_setvolume(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetFrequency(a)   staudio_out_setfrequency(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetAudioFrameSlot(a) staudio_out_setframeslot(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetMute(a)        staudio_out_setmute(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_SetOutputMode(a)  staudio_out_setoutputmode(&Audio_Handle, (a))
#define BSP_AUDIO_OUT_ChangeBuffer(a, b)   staudio_out_changebuffer(&Audio_Handle, (a), (b))

#define BSP_AUDIO_IN_InitEx(a, b, c, d) staudio_in_init(&Audio_Handle, (a), (b), (c), (d))
#define BSP_AUDIO_IN_OUT_Init(a, b, c, d, e) staudio_in_out_init(&Audio_Handle, (a), (b), (c), (d), (e))
#define BSP_AUDIO_IN_DeInit()           staudio_in_deinit(&Audio_Handle)
#define BSP_AUDIO_IN_Record(a, b)       staudio_in_record(&Audio_Handle, (a), (b))
#define BSP_AUDIO_IN_Stop(a)            staudio_in_stop(&Audio_Handle, (a))
#define BSP_AUDIO_IN_Pause()            staudio_in_pause(&Audio_Handle)
#define BSP_AUDIO_IN_Resume()           staudio_in_resume(&Audio_Handle)
#define BSP_AUDIO_IN_SetVolume(a)       staudio_in_setvolume(&Audio_Handle, (a))

#define HAL_Delay                       dly_tsk

#define RESET                           0
#define SET                             1

#ifndef TOPPERS_MACRO_ONLY

typedef enum {
  AUDIO_ERROR_NON = 0,
  AUDIO_ERROR_NOTREADY,
  AUDIO_ERROR_IO,
  AUDIO_ERROR_EOF,
}AUDIO_ErrorTypeDef;

extern LCD_Handler_t        LcdHandle;
extern TouchScreen_Handle_t TouchScreen_Handle;
extern STAUDIO_Handle_t     Audio_Handle;
extern LCD_DrawProp_t       DrawProp;

/*
 *  ؿΥץȥ
 */

extern void	main_task(intptr_t exinf);
extern void exti9_handler(void);
extern void sw_handle(void);
extern uint8_t CheckForUserInput(void);

extern void Touchscreen_Calibration(int16_t PhysX, int16_t PhysY);
extern uint16_t TouchScreen_Get_Calibrated_X(uint16_t x);
extern uint16_t TouchScreen_Get_Calibrated_Y(uint16_t y);
extern void Touchscreen_DrawBackground_Circles(uint8_t state);
extern uint8_t TouchScreen_GetTouchPosition(void);

extern void AudioPlay_demo(void);
extern void AudioLoopback_demo(void);

extern void BSP_AUDIO_OUT_TransferComplete_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_OUT_HalfTransfer_CallBack(AUDIO_Handle_t *hsai);
extern void BSP_AUDIO_IN_TransferComplete_CallBack(void *handle);
extern void BSP_AUDIO_IN_HalfTransfer_CallBack(void *handle);
extern void BSP_AUDIO_OUT_Error_CallBack(void);
extern void BSP_AUDIO_IN_Error_CallBack(void);

#endif /* TOPPERS_MACRO_ONLY */
